///<ObjektNummer>2260</ObjektNummer>

#if !defined(h_WebserverHardware)
#define h_WebserverHardware

// Defines
#define F_CPU 20000000
#define MCU ATMEGA644P

//#include <avr\io.h>
#include "Webserver.h"
#include "SpiMasterUart.h"

#include "Debug.h"
#include "Mx8_Timer.h"
#include "myEthernet.h"
#include "SD_CARD.h"
#include "SD_CARD_EXT.h"
#include "myAvr_String.h"
#include "Projekt_myEthernet_HwManager.h"
#include "M8_Uart.h"

#define String StringBig
/////// DEBUG /////////////
//#define IsDEBUG	// auch im Paket "Debug" schalten
	#define DEBUG_BAUD 500000
	#define DEBUG_UART_NR 0
	#include "debugUart.h"

class WebserverHardware : public Webserver
{

public:
	//	spiStart()
	//	erlaubt SPI mit ENC...
	void spiStart();
	//	spiStop()
	//	blockiert SPI mit ENC...
	void spiStop();
	DigitalOutLowActiv reset;
	//	Konstruktor
	WebserverHardware();

	//	Destruktor
	~WebserverHardware();

private:

protected:

	//	configHardware()
	void configHardware();
	SpiMasterUart spiMaster;

};

#endif
