/*

    myAVR-myEthernet JavaScript Lib     v1.01



    * Ajax-Fileloader, dynamic requests of data

    * myEth-Object with functions and attributes

      to create, update and configurate the myEthernet

      - support of: * TWI-temperature sensor

                    * ByteOut/In of port A/B

                    * all physical pins                                     

*/



//### html-element funktions start

function $(id){

if (document.getElementById(id)==null)

	return document.getElementsByName(id)[0];

else

	return document.getElementById(id);}

function $T(id,t)

{$(id).innerHTML=t;}

function $Ta(id,t)

{$(id).innerHTML+=t;}

//### html funktions end



//### ajax loader start

function doRequest(fileUrl,rnd) 

{

    var req;

    if (window.XMLHttpRequest) {

        req = new XMLHttpRequest();

    } else if (window.ActiveXObject) {

        try {

           req = new ActiveXObject("MSXML2.XMLHTTP");

        } catch (e) {

            try {

                req = new ActiveXObject("Microsoft.XMLHTTP");

            } catch (e) {}

        }

    }

    if (req)

    {

        if (!rnd)

           fileUrl+="&"+(Math.round(Math.random()*1000000));

        req.open("GET", fileUrl, false);

    }

    try{req.send(null);} catch(e){}

}

function readFile(fileUrl) {

    var req;

    var fileContent;

    if (window.XMLHttpRequest) {

        req = new XMLHttpRequest();   

        req.open("GET", fileUrl, false);

        if (!req)

            alert("XMLHttpRequest - Erreur objet !");           

        req.send(null);

        fileContent = req.responseText;

    } else if (window.ActiveXObject) {

        try {

           req = new ActiveXObject("MSXML2.XMLHTTP");

        } catch (e) {

            try {

                req = new ActiveXObject("Microsoft.XMLHTTP");

            } catch (e) {

                req=false;

            }

        }

        req.open("GET", fileUrl, false);

        if (!req)

            alert("XMLHttpRequest - Erreur objet !");          

        req.onreadystatechange=function()

        {

            if (req.readyState == 4) {

            fileContent = req.responseText;}

        }

        req.send(null);  

    }

    if (fileContent)

        return fileContent;

    else

        return "";

}

//### ajax loader end



//### myEth object start

var bits=new Array(0x0,0x1,0x2,0x4,0x8,0x10,0x20,0x40,0x80);

var addbits=new Array();       //optional to existing bit configuration

addbits[0]=0x100;

var bitsaddto=new Array(0x2,0x80)   //config with additional bit-state

var bittxt=new Array();

bittxt[0x0]="-";

bittxt[0x1]="digital out";

bittxt[0x2]="digital in";

bittxt[0x4]="analog input";

bittxt[0x8]="uart";

bittxt[0x10]="twi";

bittxt[0x20]="spi";

bittxt[0x40]="ByteOut";

bittxt[0x80]="ByteIn";

bittxt[0x100]="Pullup";

bittxt[0x102]="digital in + Pullup";

bittxt[0x180]="ByteIn + Pullup";

bittxt["-"]=0x0;

bittxt["digital out"]=0x1;

bittxt["digital in"]=0x2;

bittxt["analog input"]=0x4;

bittxt["uart"]=0x8;

bittxt["twi"]=0x10;

bittxt["spi"]=0x20;

bittxt["ByteOut"]=0x40;

bittxt["ByteIn"]=0x80;

bittxt["Pullup"]=0x100;

bittxt["digital in + Pullup"]=0x102;

bittxt["ByteIn + Pullup"]=0x180;

//get all pin cfgs,values -> "eth_csta.htm"

function readState()

{

    var newstat="eth_csta.htm?"+(Math.round(Math.random()*1000000)); //browser/proxycache?

    var newcfg=readFile(newstat);

    if (!newcfg)

        {alert("Impossible de lire les donn&eacute;es depuis le serveur web myEthernet !");return false;}

    newcfg=newcfg.split("\n");

    //physical pins

    for (var i=0;i<newcfg.length;i++)

    {

        var tmp="";

        if (newcfg[i].substring(0,4)=="PPIN")

        {

            newcfg[i]=newcfg[i].split("=");

            tmp=newcfg[i][2].split(";");

            if (newcfg[i][1]=="c") //current config

            {

                for(ii=0;ii<tmp.length;ii++)

                    myEth.pin[ii].aCfg=tmp[ii];

            }

            else if (newcfg[i][1]=="C") //possible config

            {

                for(ii=0;ii<tmp.length;ii++)

                {

                    myEth.pin[ii].pCfg=tmp[ii];

                    myEth.pin[ii].nr=ii;

                }

            }            

            else if (newcfg[i][1]=="v") //current value at pin

            {

                for(ii=0;ii<tmp.length;ii++)

                    myEth.pin[ii].aVal=tmp[ii];

            }

        }

        //virtual pins

        else if (newcfg[i].substring(0,4)=="VPIN")

        {

            newcfg[i]=newcfg[i].split("=");

            tmp=newcfg[i][2].split(";");

            myEth.vpin[newcfg[i][1]].aVal=tmp[0];

            myEth.vpin[newcfg[i][1]].aCfg=tmp[1];

            myEth.vpin[newcfg[i][1]].pCfg=tmp[2];

            myEth.vpin[newcfg[i][1]].nr=newcfg[i][1];

        }

        //myethernet info-strings & webserver

        else if (newcfg[i].substring(0,4)=="INFO")

        {

            newcfg[i]=newcfg[i].split("=");

            if (newcfg[i][1]=="i")  //ip

                {myEth.ip=newcfg[i][2];continue;}

            if (newcfg[i][1]=="n")  //subnetmask

                {myEth.subnet=newcfg[i][2];continue;}

            if (newcfg[i][1]=="p")  //port

                {myEth.port=newcfg[i][2];continue;}

            if (newcfg[i][1]=="m")  //mac-Adresse

                {myEth.mac=newcfg[i][2];continue;}

            if (newcfg[i][1]=="v")  //firmware version

                {myEth.version=newcfg[i][2];continue;}

            if (newcfg[i][1]=="t")  //systime

                {myEth.systime=newcfg[i][2];continue;}

        }

    }

    return true;

}      

//bitmask to txt   PE: hexwert PA:text

function stateToText(hex,gleich)

{

    if (!hex)

        return "unknow";

    if (hex.substring(0,2)=="0x") 

        {}else {hex="0x"+hex;hex-=0;}

    var cfg=new Array();

    for (var i=0;i<bits.length;i++)//all possible cfgs

    {

        if (bits[i] & hex)

            cfg.push(bittxt[bits[i]]);

    }

    //check for current cfg

    if (gleich)

    {

        cfg=new Array();

        hex-=0;

        cfg.push(bittxt[hex]);

    }

    if (cfg.length==0)

        {cfg="-";return cfg;}

    return cfg.join(",");

}

//noethweb %B0 =  

function checkEthWebActive()

{

    var testesc="%B0c0%B0";

    if (test==unescape(testesc))

        myEth.active=false;

    else

        myEth.active=true;

}

//single pin object

function ethPin(ac,pc,av,nr) // params = string

{

    this.aCfg=ac;   //cur cfg

    this.nCfg="";   //new cfg

    this.pCfg=pc;   //pos cfg

    this.aVal=av;   //cur value

    this.nr=nr;     //pinnr

    this.getaCfgTxt=function () {return stateToText(this.aCfg,true);};

    this.getpCfgTxt=function () {return stateToText(this.pCfg);};

    this.setNewCfg=function (ncfg) {this.nCfg=ncfg;};

}

function ethvPin(pins)  //pins = array of ethPin

{

    this.portVal="";    //cur value of port

    this.pin=pins;   //portnumber-array, list of phys. pins

    this.setportVal=function (val) {

                                        var ok=true;

                                        for (pinnr in this.pin)

                                        {

                                            if (myEth.pin[pinnr].aCfg & bittxt["ByteOut"])

                                            {}else ok=false;

                                            if (ok) this.portVal=val;

                                        }

                                    };

}

ethvPin.prototype=new ethPin();



var myEth = new Object();

var vpins=new Array(200,201,202,203,204,205,206,207,210,211);

var virtPins=new Array();

virtPins["TWI0"]=200;

virtPins["TWI1"]=201;

virtPins["TWI2"]=202;

virtPins["TWI3"]=203;

virtPins["TWI4"]=204;

virtPins["TWI5"]=205;

virtPins["TWI6"]=206;

virtPins["TWI7"]=207;

virtPins["portA"]=210;

virtPins["portB"]=211;

virtPins[200]="TWI0";

virtPins[201]="TWI1";

virtPins[202]="TWI2";

virtPins[203]="TWI3";

virtPins[204]="TWI4";

virtPins[205]="TWI5";

virtPins[206]="TWI6";

virtPins[207]="TWI7";

virtPins[210]="portA";

virtPins[211]="portB";

//init myEth Object

function initmyEth()

{

    myEth.active=false; //false=off, true=on

    //info

    myEth.version="";

    myEth.ip="";

    myEth.port="";

    myEth.subnet="";

    myEth.mac="";

    myEth.systime="";

    myEth.pin=new Array();

    //physical Pins

    for (p=0;p<24;p++)

        myEth.pin[p]=new ethPin();

    //pinlist of virtual pins

    var portA=new Array(0,1,2,3,12,13,14,15);

    var portB=new Array(4,5,6,7,8,9,10,11);

    var TWI=new Array(16,17);

    myEth.vpin=new Array();

    //twi tempsensor 200-207

    myEth.vpin[virtPins["TWI0"]]=new ethvPin(TWI);

    myEth.vpin[virtPins["TWI1"]]=new ethvPin(TWI);

    myEth.vpin[virtPins["TWI2"]]=new ethvPin(TWI);

    myEth.vpin[virtPins["TWI3"]]=new ethvPin(TWI);

    myEth.vpin[virtPins["TWI4"]]=new ethvPin(TWI);

    myEth.vpin[virtPins["TWI5"]]=new ethvPin(TWI);

    myEth.vpin[virtPins["TWI6"]]=new ethvPin(TWI);

    myEth.vpin[virtPins["TWI7"]]=new ethvPin(TWI);

    //portA/B 210,211

    myEth.vpin[virtPins["portA"]]=new ethvPin(portA);

    myEth.vpin[virtPins["portB"]]=new ethvPin(portB);        

    //functions

    myEth.readState=readState;

    myEth.checkWeb=checkEthWebActive;

}

//### myEth object end