/* JS-Script:
	-alle Funktionalitten des myEthernets
	-Ersetzungen und Firmware-Parameter
	-wichtigeste Umwandlungs- und Ausgabemethoden fr Webseite myEthernet (SD-Karte)
	-Anwendung des Objektes "myEth" vorangig fr fortgeschrittene Anwender	
*/

//### Translation Array for "allg" JS-Script functions ###
var langAllg=new Array();
var regex =  /web_(\w{2})/;
regex.exec(window.location.href);
var incJS=readFile('../allg/allg_' + RegExp.$1 + '.js');
eval(incJS);
//### allg. html-element fkts start
function $(id){
if (document.getElementById(id)==null)
	return document.getElementsByName(id)[0];
else
	return document.getElementById(id);}
function $F(name)
{return window.frames[name];}
function $N(id,m)
{$(id).childNodes[0].nodeValue=m;}
function $T(id,t)
{$(id).innerHTML=t;}
function $Ta(id,t)
{$(id).innerHTML+=t;}
function isArray(obj){
if (obj.constructor.toString().indexOf("Array") == -1)
  return false;
else
  return true;}
function isExist(id){
var ok = false;
if (document.getElementById(id)!=null)
    ok=true;
if (ok==false && document.getElementsByName(id)[0]!=null)
    ok=true;
return ok;}
function onoff(id,show,block)
{if (!block)
	block="inline";
$(id).style.display=(show?block:"none");}
function $C(t)
{return confirm(t);}
function $dRB(name,typ) //disabled/enable option/radiobuttons
{for(i=0;i<document.getElementsByName(name).length;i++)
	document.getElementsByName(name)[i].disabled=typ;}		
//### allg fkts end

//### convert-fkts
//PE: single number or array of numbers
//signed to unsigned
function stou(input)
{
	if (isArray(input))
	{
		for (i=0;i<input.length;i++)
			if(input[i]<0)
				input[i]=convertType(input[i]);
	}else
	{
		if(input<0)
			input=convertType(input);
	}
	return input;
}
function convertType(num)
{
	y=0;
	if (num >= -(Math.pow(2,7)))
		y=8;
	if ((num >= -(Math.pow(2,15)))&& !y)
		y=16;
	if ((num >= -(Math.pow(2,31)))&& !y)
		y=32;
	num+=Math.pow(2,y);
	return num;
}
//### convert-fkts end

//### ajax loader start
function doRequest(fileUrl,rnd) 
{
    var req;
    if (window.XMLHttpRequest) {
        req = new XMLHttpRequest();
    } else if (window.ActiveXObject) {
        try {
           req = new ActiveXObject("MSXML2.XMLHTTP");
        } catch (e) {
            try {
                req = new ActiveXObject("Microsoft.XMLHTTP");
            } catch (e) {}
        }
    }
    if (req)
    {
        if (!rnd)
           fileUrl+="&"+(Math.round(Math.random()*1000000));
        req.open("GET", fileUrl, false);
    }
    try{req.send(null);} catch(e){}
}
function readFile(fileUrl) {
    var req;
    var fileContent;
    if (window.XMLHttpRequest) {
        req = new XMLHttpRequest();   
        req.open("GET", fileUrl, false);         
        try{req.send(null);} catch(e){}
        fileContent = req.responseText;
    } else if (window.ActiveXObject) {
        try {
           req = new ActiveXObject("MSXML2.XMLHTTP");
        } catch (e) {
            try {
                req = new ActiveXObject("Microsoft.XMLHTTP");
            } catch (e) {
                req=false;
            }
        }
        req.open("GET", fileUrl, false);         
        req.onreadystatechange=function()
        {
            if (req.readyState == 4) {
            fileContent = req.responseText;}
        }
        try{req.send(null);} catch(e){}  
    }
    if (fileContent)
        return fileContent;
    else
        return "";
}
//### ajax loader end

//### tbl-loader start  PE: file=table,typ=array |*.htm,id=neue tabid,rowids=array rowids->default 0...lenght
function loadtbl(file,typ,id,rowids)    
{
	var pins=new Array();
    if (typ)
        pins=readFile(file).split("\n"); //jede zeile
    else
        pins=file.split("\n");
	var tbl_new="";
	var tmp=new Array();
	var tmp_len=0;
	var tmp_line="";
	var ergMatch="";
    for (var i=0;i<pins.length;i++)
	{
		tmp=pins[i].split("\t");
        //check leading/closing ""			
		if (tmp[0]=="" && tmp[tmp.length-1]=="")
		{tmp.shift();tmp.pop();}
        //nur volle zeilen ->    beachten -> &_uml; !
        (tmp_len<tmp.length?tmp_len=tmp.length:"");
		if (tmp_len==tmp.length)
		{
            if (i==0) //Kopfzeile/berschrift
                tmp_line="<thead valign='top'><tr><th>"+tmp.join("</th><th>")+"</th></tr></thead>";
            else
                tmp_line="<tr id='jsrow"+(rowids?rowids[i-1]:(i-1))+"'><td>"+tmp.join("</td><td>")+"</td></tr>";
            //check [PINx=value]
			ergMatch=tmp_line.match(/\[\w+=\w+\]/);
			if (ergMatch)
			{
            	tmp=ergMatch[0];
			 	tmp=tmp.substr(1,(tmp.length-2));
				tmp=tmp.split("=");
				tmp[1]=stateToText(tmp[1]);
				if (tmp[1].indexOf(",")>0)
				   tmp[1]=tmp[1].replace(/,/g,"</option><option>");									
                tmp="<select name='"+tmp[0]+"' size='1'>"+"<option>"+tmp[1]+"</option></select>";
            	tmp_line=tmp_line.replace(/\[\w+=\w+\]/,tmp); //einfgen
			}
			tbl_new+=tmp_line+"\n";
		}
	}
	if (!id)
	   id="jstab";
	tbl_new="<table class='stdc' id='"+id+"' cellspacing='0'>"+tbl_new+"</table>";
	return tbl_new;
}   
//### tbl-loader end

//### eth -> cfg/val-reader start
//Aktuelle Config von myEthernet in Tab eintragen, nur *
var tabname="jstab";  // id/name der Zieltabelle
/* Aufbau Zieltabelle fr filltab()
    <table>
      <thead></thead>
      <tbody>
        <tr><td></td>td>__Zielspalte__</td></tr>
      </tbody>
    </table>
*/
//aktuelle werte aus PE: div mit name/id = id holen, Zielspalte
function getcfg(id,spalte)
{    
  var aktval=$(id).innerHTML.split(";");
  filltab(aktval,spalte);
}
//file nachladen mit inhalt der werte/cfg
function getcfgajax(file,spalte)
{    
  var aktval=ReadFile(file).split(";");
  filltab(aktval,spalte);
}
//ein/auslenden kompletter tabspalte PE: col=spaltennr,show 1=an/0=aus, id=tabid,tab=table-id
function onoffTabCol(col,show,tab)
{
    if (!tab)
        tab=$(tabname);
    else
        tab=$(tab);
    t=0;i=0;i_td=0;td_count=0;td_count_arr=0;
    while (tab.childNodes[t] != null && t<tab.childNodes.length)
    {
        tabbody=tab.childNodes[t];
        while (tabbody.childNodes[i] != null && i<tabbody.childNodes.length)
        {
          if (tabbody.childNodes[i].tagName=="TR")
          {
              tr=tabbody.childNodes[i];
              while (tr.childNodes[i_td] != null && i_td<tr.childNodes.length)
              {
                  if (tr.childNodes[i_td].tagName=="TD" || tr.childNodes[i_td].tagName=="TH")
                  {       
                        td_count++; 
                        if (td_count==col) 
                        { 
                            tr.childNodes[i_td].style.display=(show?"":"none");
                            break;
                        }
                  }i_td++;
              }td_count=0;i_td=0;
          }i++;
        }t++;i=0;
    }
}
//fgt button fr jede zelle ein PE: tab=table-id,tar=zielspalte wo hinzu,cap=buttontext,div=buttonziel,pinarr=liste von pins fuer div
function addEditToTab(tab,tar,cap,div,pinarr)
{
    var newbtn=new Array();
    var i=0;
    if (pinarr)
        for (i=0;i<pinarr.length;i++)
            newbtn[i]=' <a href="javascript:'+div+'('+pinarr[i]+')" class="pinedit" title="'+langAllg["PIN"]+' '+pinarr[i]+' '+langAllg["change"]+'">'+cap+'</a>';  //btn
    else
        for (i=0;i<24;i++)
            newbtn[i]=' <a href="javascript:'+div+'('+i+')" class="pinedit" title="'+langAllg["PIN"]+' '+i+' '+langAllg["change"]+'">'+cap+'</a>';  //btn
    filltab(newbtn,tar,0,1,tab);
}
//fillrow , x-te spalte einer zeile ndern PE: new innerhtml,spalte,zeile,hinzufgen,hovermsg=infotext-window for mousover
//  1.zeile=0; headline nicht beachten, bekommt keine id
//  1.spalte=0
//  headline mit hovermsg => hovermsg =  "Info zum Pin|"+ ...
function changeCell(inhtm,col,row,add,hovermsg)
{
    if (hovermsg)   //infotext.js einbinden !
        inhtm='<span onmouseout="popuphidden();" onMouseover="popup(\'-260|-50|250|'+hovermsg+'\')">'+inhtm+'</span>';
    var tr=$('jsrow'+row);
    i_td=0;td_count=0;
    while (tr.childNodes[i_td] != null && i_td<tr.childNodes.length){
        if (tr.childNodes[i_td].tagName=="TD"){
            if (td_count==col){
                if (add)
                    tr.childNodes[i_td].innerHTML+=inhtm;
                else
                    tr.childNodes[i_td].innerHTML=inhtm;
                return;
            }td_count++;
        }i_td++;
    }
}
//tabelle fllen PE: Array mit Werten,tar=Zielspalte,iscfg=spalte fr akt./mgl Config, add=hinzufgen zum zelleninhalt,tab=table-id
function filltab(arr,tar,iscfg,add,tab)
{
  if (!tab)
    tab=$(tabname);  
  else
    tab=$(tab);  
  var tabbody=tab.lastChild; //tbody
  var tmp="";
  i=0;i_td=0;td_count=0;td_count_arr=0;
  while (tabbody.childNodes[i] != null && i<tabbody.childNodes.length)
  {   //tr suchen
      if (tabbody.childNodes[i].tagName=="TR")
      {
          tr=tabbody.childNodes[i];
          while (tr.childNodes[i_td] != null && i_td<tr.childNodes.length)
          {   //td suchen
              if (tr.childNodes[i_td].tagName=="TD")
              {
                 td_count++;
                 if (td_count==tar)//zielspalte
                 {  //check ob werte zum bersetzen sind, nur bei cfg
                    if (iscfg)
                        tmp=stateToText(arr[td_count_arr]);
                    else
                    {
                        if (arr[td_count_arr])
                            tmp=arr[td_count_arr];
                        else
                            tmp="???";  // ??? = unbekannt/unknown/inconnu
                    }
                    if (add)
                        tr.childNodes[i_td].innerHTML+=tmp;
                    else
                        tr.childNodes[i_td].innerHTML=tmp;
                    td_count_arr++;
                    break;
                 }
              }
              i_td++;
          }
          td_count=0;i_td=0;
      }
      i++;
  }
}

//### myEth object start
var bits=new Array(0x0,0x1,0x2,0x4,0x8,0x10,0x20,0x40,0x80);
var addbits=new Array();       //optional zur bestehenden cfg
addbits[0]=0x100;
var bittxt=new Array();
bittxt[0x0]		="-";
bittxt[0x1]		=langAllg["digitalout"];
bittxt[0x2]		=langAllg["digitalin"];
bittxt[0x4]		=langAllg["analoginput"];
bittxt[0x8]		=langAllg["uart"];
bittxt[0x10]	=langAllg["twi"];
bittxt[0x20]	=langAllg["spi"];
bittxt[0x40]	=langAllg["ByteOut"];
bittxt[0x80]	=langAllg["ByteIn"];
bittxt[0x100]	=langAllg["Pullup"];
bittxt[0x102]	=langAllg["digitalinWithPullup"];
bittxt[0x180]	=langAllg["ByteInwithPullup"];
bittxt["-"]=0x0;
bittxt[langAllg["digitalout"]]	=0x1;
bittxt[langAllg["digitalin"]]	=0x2;
bittxt[langAllg["analoginput"]]	=0x4;
bittxt[langAllg["uart"]]		=0x8;
bittxt[langAllg["twi"]]			=0x10;
bittxt[langAllg["spi"]]		=0x20;
bittxt[langAllg["ByteOut"]]	=0x40;
bittxt[langAllg["ByteIn"]]	=0x80;
bittxt[langAllg["Pullup"]]	=0x100;
bittxt[langAllg["digitalinWithPullup"]]	=0x102;
bittxt[langAllg["ByteInwithPullup"]]	=0x180;
var bitsaddto=new Array(0x2,0x80);   //wo darf "addbits" addiert werden
//get all pin cfgs,values -> "eth_csta.htm"
//PE: newstat=filename (optional)
//    request=filename neu anfordern =1 / aus param1 daten verarbeiten =0
function readState(newcfg,request)
{
	if (!newcfg && !request)//no param
	{
    	newcfg="eth_csta.htm?"+(Math.round(Math.random()*1000000)); //browser/proxycache?
    	newcfg=readFile(newcfg);
	}
	else if (newcfg && request)	//param 1+2 set
	{
		newcfg=newcfg+"?"+(Math.round(Math.random()*1000000)); //browser/proxycache?
		newcfg=readFile(newcfg);
	}
	//param=stringlist divider="\n"
	if (!newcfg)
        return false;
    newcfg=newcfg.split("\n");
    //physical pins
    for (var i=0;i<newcfg.length;i++)
    {
        var tmp="";
        if (newcfg[i].substring(0,4)=="PPIN")
        {
            newcfg[i]=newcfg[i].split("=");
            tmp=newcfg[i][2].split(";");
            if (newcfg[i][1]=="c") //aktuelle Konfig
            {
                for(ii=0;ii<tmp.length;ii++)
                    myEth.pin[ii].aCfg=tmp[ii];
            }
            else if (newcfg[i][1]=="C") //mgl. Konfig
            {
                for(ii=0;ii<tmp.length;ii++)
                {
                    myEth.pin[ii].pCfg=tmp[ii];
                    myEth.pin[ii].nr=ii;
                }
            }
            else if (newcfg[i][1]=="v") //akt. Wert
            {
                for(ii=0;ii<tmp.length;ii++)
                    myEth.pin[ii].aVal=tmp[ii];
            }
            else	//ist einzelner ppin
	        {
	            myEth.pin[newcfg[i][1]].aVal=tmp[0];
	            myEth.pin[newcfg[i][1]].aCfg=tmp[1];
	            myEth.pin[newcfg[i][1]].pCfg=tmp[2];
	            myEth.pin[newcfg[i][1]].nr=newcfg[i][1];
	        }
        }
        //virtual pins
        else if (newcfg[i].substring(0,4)=="VPIN")
        {
            newcfg[i]=newcfg[i].split("=");
            tmp=newcfg[i][2].split(";");
            myEth.vpin[newcfg[i][1]].aVal=tmp[0];
            myEth.vpin[newcfg[i][1]].aCfg=tmp[1];
            myEth.vpin[newcfg[i][1]].pCfg=tmp[2];
            myEth.vpin[newcfg[i][1]].nr=newcfg[i][1];
        }
        //myethernet info & webserver
        else if (newcfg[i].substring(0,4)=="INFO")
        {
            newcfg[i]=newcfg[i].split("=");
            if (newcfg[i][1]=="i")  //ip
                {myEth.ip=newcfg[i][2];continue;}
            if (newcfg[i][1]=="n")  //subnetmask
                {myEth.subnet=newcfg[i][2];continue;}
            if (newcfg[i][1]=="p")  //port
                {myEth.port=newcfg[i][2];continue;}
            if (newcfg[i][1]=="m")  //mac-Adresse
                {myEth.mac=newcfg[i][2];continue;}
            if (newcfg[i][1]=="v")  //firmware version
                {myEth.version=newcfg[i][2];continue;}
            if (newcfg[i][1]=="b")  //firmware build
                {myEth.build=newcfg[i][2];continue;}
            if (newcfg[i][1]=="t")  //systime
                {myEth.systime=newcfg[i][2];continue;}
            if (newcfg[i][1]=="h")  //hardware
                {myEth.hw=newcfg[i][2];continue;}
			//socket infos
            if (newcfg[i][1]=="Cs") //socket number
                {myEth.sockets=newcfg[i][2];continue;}
            if (newcfg[i][1]=="Cr") //socket receive buffer size
                {myEth.sockRecBuf=newcfg[i][2];continue;} 
            if (newcfg[i][1]=="Cg") //socket get request buffer size
                {myEth.sockGetBuf=newcfg[i][2];continue;} 
            //Heap
            if (newcfg[i][1]=="Sr") //minimum of free heap memory
                {myEth.minfreeHeap=newcfg[i][2];continue;}
            if (newcfg[i][1]=="Sh") //size of heap
                {myEth.sizeHeap=newcfg[i][2];continue;}	
            if (newcfg[i][1]=="SU") //max used heap
                {myEth.maxusedHeap=newcfg[i][2];continue;}
            if (newcfg[i][1]=="Sf") //sum free heap
                {myEth.sumfreeHeap=newcfg[i][2];continue;}
            if (newcfg[i][1]=="Su") //sum of used heap
                {myEth.sumusedHeap=newcfg[i][2];continue;}
            if (newcfg[i][1]=="Sp") //memory parts of heap (fragmentation)
                {myEth.partsHeap=newcfg[i][2];continue;}
            if (newcfg[i][1]=="SS") //max used stack
                {myEth.maxusedStack=newcfg[i][2];continue;}
        }
    }
    return true;
}
//128Byte Ram und 128Byte Eeprom einlesen (viele Daten+Ersetzungen!)
//type=true -> file=array
function readMem(file,type)
{
	if (!myEth.active)
		return false;
	readConfigcfg();
	if (!type)
	{
		if (file)
			file=file+"?"+(Math.round(Math.random()*1000000)); //browser/proxycache?
		else
	    	file="eth_mem.htm?"+(Math.round(Math.random()*1000000)); //browser/proxycache?
	    var newmem=readFile(file);
	    if (!newmem)
	        {alert(langAllg["readMemERR"]);return false;}
    }
    else
    	var newmem=file;
    newmem=newmem.split("\n");
    for (var i=0;i<newmem.length;i++)
    {
        //virtual mem-pins
        if (newmem[i].substring(0,4)=="VPIN")
        {
            newmem[i]=newmem[i].split("=");
            myEth.vpin[newmem[i][1]] = parseInt(newmem[i][2]);
        }
    }
    return true;
}
//config.cfg auslesen und RAM/EEPROM Konfiguration auslesen
var readConfigcfgDone=false;
function readConfigcfg()
{
	if (readConfigcfgDone)
		return true;
	var file="../config.cfg?"+(Math.round(Math.random()*1000000)); //browser/proxycache?
	var newcfg=readFile(file);
    if (!newcfg)
        {alert(langAllg["readCfgERR"]);return false;}
    newcfg=newcfg.split("\n");
    //sharedRamSize und sharedEepromSize auslesen, rest per ersetzungen
    for (var i=0;i<newcfg.length;i++)
    {
    	newcfg[i]=newcfg[i].split("=");
        if (newcfg[i][0].toUpperCase()=="SHAREDRAMSIZE")
            myEth.sharedRamSize=parseInt(newcfg[i][1]);
        if (newcfg[i][0].toUpperCase()=="SHAREDEEPROMSIZE")
            myEth.sharedEepromSize=parseInt(newcfg[i][1]);
    }
    readConfigcfgDone=true;
    return true;  
}
//bitmaske in text umwandeln PE: hexwert PA:text
function stateToText(hex,gleich)
{
    if (!hex)
        return langAllg["unknown"];   // ??? = unbekannt/unknown/inconnu
    if (hex.substring(0,2)=="0x") 
        {}else {hex="0x"+hex;hex-=0;}
    var cfg=new Array();
    for (var i=0;i<bits.length;i++)//alle mgl. cfgs
    {
        if (bits[i] & hex)
            cfg.push(bittxt[bits[i]]);
    }
    //check auf aktuelle cfg
    if (gleich)
    {
        cfg=new Array();
        hex-=0;
        cfg.push(bittxt[hex]);
    }
    if (cfg.length==0)
        {cfg="-";return cfg;}
    return cfg.join(",");
}
//noethweb %B0 = grad
function checkEthWebActive()
{
	myEth.active=false;
    var testesc="%B0c0%B0";
    if (test!=unescape(testesc))
        myEth.active=true;
}
//single Pin-Object
function ethPin(ac,pc,av,nr) // params als strings !
{
    this.aCfg=ac;   //akt. cfg
    this.nCfg="";   //new cfg
    this.pCfg=pc;   //mgl. cfg
    this.aVal=av;   //akt wert
    this.nr=nr;     //pinnr
    this.getaCfgTxt=function () {return stateToText(this.aCfg,true);};
    this.getpCfgTxt=function () {return stateToText(this.pCfg);};
    this.setNewCfg=function (ncfg) {this.nCfg=ncfg;};
}
//virtual Pin-Object
function ethvPin(pins)  //pins = array of ethPin
{
    this.portVal="";    //akt wert des ports
    this.pin=pins;   //portnumber-array, list of phys. pins
    this.setportVal=function (val) {
        var ok=true;
        for (pinnr in this.pin)
        {
            if (myEth.pin[pinnr].aCfg & bittxt["ByteOut"])
            {}else ok=false;
            if (ok) this.portVal=val;
        }
    };
}
ethvPin.prototype=new ethPin();

var myEth = new Object();
var vpins=new Array(200,201,202,203,204,205,206,207,210,211);
var virtPins=new Array();
virtPins["TWI0"]=200;
virtPins["TWI1"]=201;
virtPins["TWI2"]=202;
virtPins["TWI3"]=203;
virtPins["TWI4"]=204;
virtPins["TWI5"]=205;
virtPins["TWI6"]=206;
virtPins["TWI7"]=207;
virtPins["portA"]=210;
virtPins["portB"]=211;
virtPins[200]="TWI0";
virtPins[201]="TWI1";
virtPins[202]="TWI2";
virtPins[203]="TWI3";
virtPins[204]="TWI4";
virtPins[205]="TWI5";
virtPins[206]="TWI6";
virtPins[207]="TWI7";
virtPins[210]="portA";
virtPins[211]="portB";
//init myEth Object
function initmyEth()
{
    myEth.active=false; //false=off, true=on
    //info
    myEth.version="";
    myEth.build="";
    myEth.ip="";
    myEth.port="";
    myEth.subnet="";
    myEth.mac="";
    myEth.systime="";
    myEth.hw="";
    //sockets
    myEth.sockets="";
    myEth.sockRecBuf="";
    myEth.sockGetBuf="";
    //default: sharedRamSize=128 sharedEepromSize=128
    myEth.sharedRamSize=128;
    myEth.sharedEepromSize=128;
    //speicher	(bytes)
    myEth.minfreeHeap="";
    myEth.sizeHeap="";
    myEth.maxusedHeap="";
    myEth.sumfreeHeap="";
    myEth.sumusedHeap="";
    myEth.partsHeap="";
    myEth.maxusedStack="";
    
    myEth.pin=new Array();
    //physical Pins
    for (p=0;p<24;p++)
        myEth.pin[p]=new ethPin();
    //pinlist fr virtuelle pins
    var portA=new Array(0,1,2,3,12,13,14,15);
    var portB=new Array(4,5,6,7,8,9,10,11);
    var TWI=new Array(16,17);
    myEth.vpin=new Array();
    //twi tempsensor 200-207
    myEth.vpin[virtPins["TWI0"]]=new ethvPin(TWI);
    myEth.vpin[virtPins["TWI1"]]=new ethvPin(TWI);
    myEth.vpin[virtPins["TWI2"]]=new ethvPin(TWI);
    myEth.vpin[virtPins["TWI3"]]=new ethvPin(TWI);
    myEth.vpin[virtPins["TWI4"]]=new ethvPin(TWI);
    myEth.vpin[virtPins["TWI5"]]=new ethvPin(TWI);
    myEth.vpin[virtPins["TWI6"]]=new ethvPin(TWI);
    myEth.vpin[virtPins["TWI7"]]=new ethvPin(TWI);
    //portA/B 210,211
    myEth.vpin[virtPins["portA"]]=new ethvPin(portA);
    myEth.vpin[virtPins["portB"]]=new ethvPin(portB);
    //methoden
    myEth.readState=readState;
    myEth.readMem=readMem;
    myEth.checkWeb=checkEthWebActive;
}
//### myEth object end